//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
BOOL TForm1::LoadSpliterDll()
{
	m_hinstLib = LoadLibrary("pdfspliter.dll");
	if( m_hinstLib == NULL ){ 
		return FALSE;
	}

	pMSplitBegin = (MSplitBegin *)GetProcAddress(m_hinstLib, "MSplitBegin");
	if( pMSplitBegin == NULL ){ 
		FreeSpliterDll(); 
		return FALSE;
	}
	pMSplit = (MSplit *)GetProcAddress(m_hinstLib, "MSplit");
	if( pMSplit == NULL ){ 
		FreeSpliterDll(); 
		return FALSE;
	}
	pMSplitEnd = (MSplitEnd *)GetProcAddress(m_hinstLib, "MSplitEnd");
	if( pMSplitEnd == NULL ){ 
		FreeSpliterDll(); 
		return FALSE;
	}
	pMWatermark = (MWatermark *)GetProcAddress(m_hinstLib, "MWatermark");
	if( pMWatermark == NULL ){ 
		FreeSpliterDll(); 
		return FALSE;
	}
	return TRUE;
}
//---------------------------------------------------------------------------
BOOL TForm1::FreeSpliterDll()
{
	if( m_hinstLib ){
        FreeLibrary(m_hinstLib);
	}
	return TRUE;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
	if( LoadSpliterDll() == FALSE ){
		ShowMessage("Load pdfspliter.dll failed!");
		return;
	}
	
	long id = pMSplitBegin("test.pdf",NULL);
	if(id==-1){
		ShowMessage("PDF file unexist or damaged!");
		FreeSpliterDll();
		return;
	}
	if(id==-2){
		ShowMessage("PDF file is restricted!");
		FreeSpliterDll();
		return;
	}

	long fsize=16;
	long fcolor=255;//red
	long position=2;//Top-Center
	long angle=0;
	long xoff=0;
	long yoff=0;
    long asbackground=0;
	//Stamping
	pMWatermark(id,"Split pdf into single pages",fsize,fcolor,position,angle,xoff,yoff,asbackground);

	long mode = 1;
	char outPath[256];
	strcpy(outPath,"split");
	pMSplit(id,outPath,mode,NULL);

	pMSplitEnd(id);

	FreeSpliterDll();
	ShowMessage("Split finished!");
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button2Click(TObject *Sender)
{
	if( LoadSpliterDll() == FALSE ){
		ShowMessage("Load pdfspliter.dll failed!");
		return;
	}
	
	long id = pMSplitBegin("test.pdf",NULL);
	if(id==-1){
		ShowMessage("PDF file unexist or damaged!");
		FreeSpliterDll();
		return;
	}
	if(id==-2){
		ShowMessage("PDF file is restricted!");
		FreeSpliterDll();
		return;
	}

	long mode = 2;
	char outFile[256];
	strcpy(outFile,"Deleted.pdf");
	pMSplit(id,outFile,mode,"3-8");

	pMSplitEnd(id);

	FreeSpliterDll();
	ShowMessage("Delete finished!");
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button3Click(TObject *Sender)
{
	if( LoadSpliterDll() == FALSE ){
		ShowMessage("Load pdfspliter.dll failed!");
		return;
	}
	
	long id = pMSplitBegin("test.pdf",NULL);
	if(id==-1){
		ShowMessage("PDF file unexist or damaged!");
		FreeSpliterDll();
		return;
	}
	if(id==-2){
		ShowMessage("PDF file is restricted!");
		FreeSpliterDll();
		return;
	}

	long mode = 3;
	char outFile[256];
	strcpy(outFile,"Extract.pdf");
	pMSplit(id,outFile,mode,"3-8,9,15");

	pMSplitEnd(id);

	FreeSpliterDll();
	ShowMessage("Extract finished!");
}
//---------------------------------------------------------------------------

 